
{rewrite of original Basic program on BS2P40 to SPIN on Propeller.  1-18-20 }


{AutoTunnerR8}
CON
  _clkmode        = xtal1 + pll16x                      'Standard clock mode * crystal frequency = 80 MHz
  _xinfreq        = 5_000_000

  Attcomp         = -48.0                               'Compensation db for power calc, works with ADC,
                                                        'ADC affects SWR calc, ATT affects power calc 
                                                        'When setting up always adjust ADC before ATT

  ADC             = 0.055                               'Orig .04884 yeilds high swr answers,
                                                        '8307 is 25mv/db, 1298 is 5v/4096bit = 1.2mv/bit,
                                                        '1.2mv/bit / 25mv/db = adc (.0448dbm/bit)

  Floor           = %1100100000                         'floor = 800 , ADC floor ,no signal                                                                              
                                                                                
  CmdReadValue    = $00
  CmdWriteValue   = $01
  CmdWriteString  = $02
  CmdSetContrast  = $04
  CmdObjEvent     = $05
  CmdRaisedEvent  = $07
  AckResp         = $06                                 'Ack Nak response codes         
  NakResp         = $15
  Fpin            = 11                                  'Pin that monitors freq
  rxpin           = 13                                  'Display Rpin
  txpin           = 12                                  'Display Tpin

  times           = 25                                  'number of samples taken in ADC

  cs              = 2                                   'MCP3202 cs pin
  clk             = 4                                   'MCP3202 clk pin
  dataio          = 3                                   'MCP3202 data pin
  
  'cs              = 24                                  'LTC1298 cs Pin
  'clk             = 25                                  'LTC1298 clk Pin
  'dataio          = 26                                  'LTC1298 Data Pin
  floorfreq       = 100                                 'Ignore frequency if below this, no signal
  CwCcwPin        = 14                                  'Sets CW or CCW
  C1stpPin        = 1                                   'Pin for C1 step pulses
  L1stpPin        = 0                                   'Pin for L step pulses
  C2stpPin        = 17                                  'Pin for C2 step pulses
  PulDur          = 6700                                'Pulse duration 6700 ` 80us
  MtrPause        = 80000                               'Delay for motor recovery after pulsout 10 ms 
  LimitDetect     = 5                                   'LimitDetect Pin
  AmpOffPin       = 9                                   'Amp Offline pin
  T24voff         = 7                                   '24v off pin
  'tune            = 1                                  ' 1=manual, 0=auto
  wait1           = true                                'wait for output from display
  
VAR
  long fpwrw, rpwrw, swr, stepcntTot[3], OldstepcntTot[3], oldState[3], newState[3], reverseFlag[3]
  long frequency1, frequency2, oldFrequency, start, stop, total, stepcnt[3], newencstat, oldencstat, zz  
  word addr[4], oldstepcnt[3]
  Byte ChkSum, i, transfer, tune, reset, poff, Nstep
  
OBJ    fMath     : "Float32"
       PST       : "Parallax Serial Terminal"           'used for comments to debug   
       LcdSerial : "FullDuplexSerialPlus"
       MCP3202    :  "MCP3202"
PUB Main   | localindex
      pst.Start(115_200)                                'Start Parallax Serial Terminal
      fMath.start                                       'Start Floating point Math
      InitDisplay                                       'Zero out display                        
      MCP3202.start(dataio, clk, cs, %0011)
      waitcnt(80000 + cnt)
       
      zz  := MCP3202.in(0)
           PST.Str(String(pst#NL," zz = "))  
           PST.dec(zz)   
     repeat localIndex from 0 to 2                     'Initialize encoder status

        oldState[localIndex] := ina[pinA[localindex]..pinB[localIndex]]
        oldencstat := INA[18..23] 
  
    Process
    
PUB Process      
    Pst.Str(string(11, 13, "Process")) 
 repeat    
    IF Tune == 0 
      CASE Nstep
        0:
            PST.Str(String(pst#NL))
            Pst.Str(string(11, 13, "PHOVER"))
            PST.Str(String(pst#NL))
          Hover         
        1:
            PST.Str(String(pst#NL))
            Pst.Str(string(11, 13, "PCALCSWR"))
            PST.Str(String(pst#NL))
          Calcswr       
        2:
            PST.Str(String(pst#NL))
            Pst.Str(string(11, 13, "PCHECKTUNE"))
            PST.Str(String(pst#NL)) 
           Checktune        
        3:
            PST.Str(String(pst#NL))
            Pst.Str(string(11, 13, "PCHKBAND"))
            PST.Str(String(pst#NL)) 
          ChkBand
      
    else
       Mainloop    
   
       
PUB Hover
Pst.Str(string(11, 13, "hover")) 
    Repeat                                       
        Dira := Fpin
        Ctra := 0
        Ctra := (%01010 << 26)|(%001 << 23)|(0 << 9)|(Fpin)
        Frqa := 1
        Phsa := 0
        waitcnt(20_000_000 + cnt)                       'Count freq for 250ms
        Frequency1 := Phsa/1000
        Frequency1 := Frequency1*4 
        if frequency1 < floorfreq
                                                                  '
             'buttons
             Pst.Str(string(11, 13, "Sig Search"))             
           newencstat := INA[18..23]    
          IF oldencstat <> newencstat  
            tune := 1
            return 
 'above should be  nstep := 0, return                             
        elseif frequency1 > 0  
         
          Dira := Fpin                                  'Measure frequency1 
          Ctra := 0
          Ctra := (%01010 << 26)|(%001 << 23)|(0 << 9)|(Fpin)                   
          Frqa := 1                                                             
          Phsa := 0
          waitcnt(20_001_200 + cnt)                     'Added 1200 cnts for freq correction                                            
          Frequency1 := Phsa/1000
          Frequency1 := Frequency1*4
   '       

          Dira := Fpin                                  'Measeure frequency2
          Ctra := 0
          Ctra := (%01010 << 26)|(%001 << 23)|(0 << 9)|(Fpin)                   
          Frqa := 1
          Phsa := 0
          waitcnt(20_001_200 + cnt)
          Frequency2 := Phsa/1000
          Frequency2 := Frequency2*4
          
          IF frequency2  <> frequency1
                      
            PST.Str(String(pst#NL,"<> ")) 
            nstep := 0
            return                                      'If Freq1 <> Freq2 then bad measure, try agn
                 
          WriteObjValue($0F,$03,Frequency1)             'Write freuency to display
           
          IF Frequency1 == oldfrequency
           nstep := 1
           return
          elseif nstep := 2           
            return
 
           
PUB CheckTune | genword2   
    PST.Str(String(pst#NL," CheckTune "))   
    genword2 :=||(frequency1-oldfrequency)
    oldfrequency := frequency1
      PST.Str(String(pst#NL," genword2 =  "))
       PST.dec(genword2)
      
     Case genword2
          50..20000:
            oldfrequency := frequency1                    
            Nstep := 3
             return

          0..49 :
            oldfrequency := frequency1
            Nstep := 1
            Pst.Str(string(pst#NL,"ChkTuneNstep = ")) 
             Pst.Dec(nstep)
             return 

          Other:       
             nstep := 2
             PST.Str(String(pst#NL," out of range "))      
             return
   
    
PUB ChkBand   | x,y,stp,temp1,temp2
 PST.Str(String(pst#NL," ChkBand "))
     
        Case frequency1
           1800..1900:   x:=0            
           1901..2000:   x:=4       
           3500..3575:   x:=8      
           3576..4000:   x:=12                    
           7000..7150:   x:=16      
           7151..7300:   x:=20      
           10100..10150: x:=24      
           14000..14150: x:=28      
           14151..14350: x:=32      
           18068..18168: x:=36      
           21000..21200: x:=40      
           21201..21450: x:=44      
           24890..24990: x:=48      
           28000..28300: x:=52      
           28301..28600: x:=56      
           28601..29000: x:=60      
           Other:
              PST.Str(String(pst#NL," Freq1 out range "))                        
             nstep := 0            
             return
      addr[1] := MyData[x]                              'Retrieve C1 stpcnt                
      
      addr[2] := Mydata.byte[x+2]                       'Retrieve lowbyte of stpcnt,2nd byte of the 
      addr[2] := (addr[2]<<8) | Mydata.byte[x+1]        'word (x+2),shift byte2 8 bits left, add byte1(x+1), 
                                                        'stored in memory as byte1=lsb and byte2 = msb                                                 
                                                        'This combines byte1 and byte2 to a word
      addr[3] := MyData[x+3]                            'Retrieve C2 stpcnt                                                 
    
      PST.Str(String(pst#NL," C1Lookup = "))                                      
          PST.dec(addr[1])
      PST.Str(String(pst#NL," L1Lookup = "))                                      
          PST.dec(addr[2])
      PST.Str(String(pst#NL," C2Lookup = "))                                    
          PST.dec(addr[3])

            
                   
 '=================================Set Components to Freq======================================================
      
   x := 1
  repeat  3
          temp1 := addr[x]
          temp2 := stepcnt[x]

     IF temp1  > temp2
          OUTA[CwCcwpin] := 1  
     else
            OUTA[CwCcwpin] := 0
                                                                        
    stp := ||(addr[x]-stepcnt[x])                       'calculate number of steps needed
       
        Case x                                          'determines which pin to pulse
           x := 1: stpPin := C1stpPin                
           x := 2: stpPin := L1stpPin               
           x := 3: stpPin := C2stpPin
 
        y := 0
          repeat  stp                                   'move component to preset
             PULSOUT (stpPin,PulDur)             
             y++

          stepcnt[x-1] := addr[x]                       'Change addr[1-3] to stepcnt[0-2]          
    x++
           
  WriteObjValue($0F,$04,stepcnt[0])
  WriteObjValue($0F,$05,stepcnt[1])
  WriteObjValue($0F,$06,stepcnt[2])

  PST.Str(String(pst#NL," C1 = "))                                      
  PST.dec(stepcnt[0])
  PST.Str(String(pst#NL," L1 = "))                                      
  PST.dec(stepcnt[1])
  PST.Str(String(pst#NL," C2 = "))                                    
  PST.dec(stepcnt[2])
  Nstep := 1
  return

  

PUB CalcSWR  | q,w,r,r2,a,b ,c,d,e,f,g,h,j,k,m,x,z,pwrmw,top,bot,ADCfwdin,ADCrefin
  
  PST.Str(String(pst#NL)) 
  PST.Str(String(pst#NL," CalcSWR "))
 
 'Tstart
           r := 0
          r2 := 0 
        
       repeat times                                     'sample forward and reflected voltages times      
'          q  := adc1.GetADC(0)
           q  := MCP3202.in(0)
           PST.Str(String(pst#NL," q = "))  
           PST.dec(q)                
               if q < floor                             'check to see if you still have signal, if not,
                 nstep := 0
                 return                                 'break sampling                  
                                                                          
           'w := adc1.GetADC(1)
           w := MCP3202.in(1)
           PST.Str(String(pst#NL," w = "))  
           PST.dec(w)  
           r := q + r
          r2 := w + r2
                             
      a := r / times
      b := r2 / times                                   'averge sampling
      
        PST.Str(String(pst#NL," a = "))  
        PST.dec(a)
        PST.Str(String(pst#NL," b = "))  
        PST.dec(b)
            
        ' Solve a floating point math problem and display the result.
        
    ADCfwdin := fmath.ffloat(a) 
    ADCrefin := fmath.ffloat(b) 
            'fstring.setprecision(4)                    'set floating point math precision 4 places
           d := fmath.Fsub(ADCfwdin,ADCrefin)           'Diff of Fwd-Ref      
           f := fmath.FMul(d,adc)                       'Diff x adc = dbm   
           x := fmath.Fdiv(f,20.0)                      'CoEff of Rho calc    
           g := fmath.Pow(10.0,x)                       'Rho                      
         top := fmath.Fadd(g,1.0)                       'Rho + 1
         bot := fmath.Fsub(g,1.0)                       'Rho - 1
         swr := fmath.Fdiv(top,bot)                     '(Rho + 1)/(Rho - 1) = SWR
         swr := fmath.Fabs(swr)                         'SWR
         swr := fmath.FMul(swr,100.0)                   'convert for leddiit display
         swr := fmath.FTrunc(swr)                       'convert swr to integer
            PST.Str(String(pst#NL, "SWR = "))
           PST.dec(swr)

    'Calculate forward power
           k := fmath.FMul(ADCfwdin,adc)
           h := fmath.Fadd(k,ATTcomp)                   'add attcomp to comp for coupler, -84 for intercept
           j := fmath.Fdiv(h,10.0)
       pwrmw := fmath.pow(10.0,j)                       'forward power in milliwatts
       fpwrw := fmath.fdiv(pwrmw,1000.0)                'forward power in watts
       fpwrw := fmath.FTrunc(fpwrw)
       
           PST.Str(String(pst#NL, "Pow = "))
           PST.dec(fpwrw)  

       ' Scaling code for slider bars
    {   
            If fpwrw < 100.0
              Fpwrw := fpwrw/100.0                      'if pwr is less than 100, full scale equals 100
             else   
             Fpwrw := fpwrw/1500.0                      'if pwr is reater than 100, full scale equals 1500
              Fpwrw := fmath.FMul(fpwrw,100)            'convert perecentae of full scale to integer
  
       'Calculate reflected power                                         }
           m := fmath.FMul(ADCrefin,adc)
           h := fmath.Fadd(m,ATTcomp)                   'add attcomp to comp for coupler, -84 for intercept
           j := fmath.Fdiv(h,10.0)
       pwrmw := fmath.pow(10.0,j)                       'reflected power in milliwatts
       rpwrw := fmath.fdiv(pwrmw,1000.0)                'reflected power in watts
       rpwrw := fmath.FTrunc(rpwrw)                     'convert rpwrw to integer
                                   
            WriteObjValue($0F,$00,swr)                  'write to 3 digit, 2 decimal leddigit
            WriteObjValue($0F,$02,rpwrw)                'Write reflected power to leddigits2                   
            WriteObjValue($0B,$00,rpwrw)                'Write reflected power to gauge0, 100w full scale                                                   
            WriteObjValue($0F,$01,fpwrw)                'Write forward power to Leddigit1         
            WriteObjValue($0B,$01,fpwrw)                'Write forward power to slider gauge1
           
            Nstep := 1
             PST.Str(String(pst#NL," Swr Nstep = "))                                      
              PST.dec(nstep)
               PST.Str(String(pst#NL))
            
            ' Tstop  
              
PUB Tuner
      PST.Str(String(pst#NL," Tune "))
      hover 
         ' ++++++++++++++++++++++++++++All PUB below here are called by other subs++++++++++++++++++++++++++++++++

PUB Buttons   
   
 

   ReadObjValue($21,$01)   
    Case transfer          
           $00:                                         'Auto Tune  
             tune := 0             
           $01:                                         'Manual Tune
             Tune := 1                                       
                         
   ReadObjValue($21,$02)   
    Case transfer          
           $00:                                         'Green, not pushed  
             reset := 0                                       
           $01:                                         'Red, Pushed, reest requested
             'WriteObjValue($21,$02,$00)
             ResetTuner
                          
   ReadObjValue($21,$03)   
    Case transfer          
           $00:                                         'Green, not pushed  
             poff := 0                                       
           $01:                                         'Red, Pushed, reest requested
             Off             
                         

PUB MainLoop | localIndex,x
    x := 0  
    Pst.Str(string(pst#NL,"mainloop "))
    WriteObjValue($21,$01,$01)
   
  repeat while  tune == 1
     'buttons
    x++
    IF x => 20000
      Tune := 0
      WriteObjValue($21,$01,$00)
      process
   'This should be nstep=0,return?                         
    repeat localIndex from 0 to 2
       result := CheckForChange(localIndex)
       
      if result  ' Any non-zero value will be satisfy condition
        ProcessChange(localIndex)

        Pst.Str(string(pst#NL,"Encoder # "))
        Pst.Dec(localIndex)
        Pst.Str(string(" = "))
        Pst.Dec(stepcnt[localIndex])
        if reverseFlag[localIndex]
          Pst.Str(string(" (Reverse)"))
          OUTA[14] := 0
        else
          Pst.Str(string(" (Forward)"))
          OUTA[14] := 1
                                                                 
        IF stepcnt[localindex] < upperlimit[localindex] AND stepcnt[localindex] => 0      'If stepcnt is within limits, execute pulse
           PULSOUT (stppin[localindex],PulDur)                                            'and move stepper
           
           Pst.Str(string(pst#NL,"Pulse"))
           calcswr
           case localindex
            $00 :  WriteObjValue($0F,$04,stepcnt[localindex])
            $01 :  WriteObjValue($0F,$05,stepcnt[localindex])
            $02 :  WriteObjValue($0F,$06,stepcnt[localindex])
           oldencstat := INA[18..23] 
           x := 0 
           Pst.Str(string(pst#NL,"endopenloop"))
       
PUB CheckForChange (checkindex)
' result starts as zero. Zero is also considered false.
' Returns zero if no change. Returns true (aka -1) is change is found.
  
  newState[checkIndex] := ina[pinA[checkIndex]..(pinB[checkIndex] )]
  result := newState[checkIndex] <> oldState[checkIndex]

{PUB ProcessChange(checkindex)

  if newState[checkindex] == forward[oldState[checkindex]]
    reverseFlag[checkindex] := false 
    stepcnt[checkindex]++
  elseif newState[checkindex] == reverse[oldState[checkindex]]
    reverseFlag[checkindex] := true 
    stepcnt[checkindex]--

  oldState[checkindex] := newState[checkindex]}
    
PUB ProcessChange(localIndex)

  case oldState[localIndex]
    %00:
      case newState[localIndex]
        %01:
          reverseFlag[localIndex] := false ' false equals zero
          stepcnt[localIndex]++
       
        %11:
          'Error. Add flag to indicate encoder skipped a position.
        %10:
          reverseFlag[localIndex] := true
          stepcnt[localIndex]--
    %01:
      case newState[localIndex]
        %11:
          reverseFlag[localIndex] := false ' false equals zero
          stepcnt[localIndex]++
        %10:
          'Error. Add flag to indicate encoder skipped a position.
        %00:
          reverseFlag[localIndex] := true
          stepcnt[localIndex]--
    %11:
      case newState[localIndex]
        %10:
          reverseFlag[localIndex] := false ' false equals zero
          stepcnt[localIndex]++
        %00:
          'Error. Add flag to indicate encoder skipped a position.
        %01:
          reverseFlag[localIndex] := true
          stepcnt[localIndex]--
          
    %10:
      case newState[localIndex]
        %00:
          reverseFlag[localIndex] := false ' false equals zero
          stepcnt[localIndex]++
        %10:
          'Error. Add flag to indicate encoder skipped a position.
        %11:
          reverseFlag[localIndex] := true
          stepcnt[localIndex]--

  oldState[localIndex] := newState[localIndex]


PUB PULSOUT(Pin,Duration)  
{{
   Duration is CkCycles
   5000 ~ 74us
   6750 ~ 100us
   14750 ~ 200us
     BS2.Pulsout(500) 
       ' 1 mS pulse
}}
  'Pst.Str(string(11, 13, "Pulse"))
  DIRA[pin] := 1                                        ' Set to output                                         
  !OUTA[pin]                                            ' set to opposite state, ! previous to OUTA toggles pin
  waitcnt(Duration + cnt)                               ' wait until clk gets there 
  !OUTA[pin]                                            ' return to orig. state
   waitcnt(MtrPause + cnt)                              'wait for stepper to finish      
PUB InitDisplay | Ctr                             
   
  'Init comm port
  LcdSerial.start(rxpin, txpin, 0, 9600)                'Set your baud of your display in 4D Workshop software

  WriteObjValue($0A,$00,$00)                            'Ensure default form (form 0 is displayed)
  WriteObjValue($0F,$00,$00)                            'Zero leddigit00  SWR
  WriteObjValue($0F,$01,$00)                            'Zero leddigit01  Fwd Pow
  WriteObjValue($0F,$02,$00)                            'Zero leddigit02  Ref Pow
  WriteObjValue($0F,$03,$00)                            'Zero leddigit03  Freq
  WriteObjValue($0F,$04,$00)                            'Zero leddigit04  C1 stepcnt
  WriteObjValue($0F,$05,$00)                            'Zero leddigit05  L1 stepcnt
  WriteObjValue($0F,$06,$00)                            'Zero leddigit05  C2 stepcnt


  WriteObjValue($0B,$00,$00)                            'Zero gauge0  Ref Pow
  WriteObjValue($0B,$01,$00)                            'Zero gauge1  Fwd Pow
PUB ResetTuner      

    Reset := 0

    OUTA[AmpOffPin] := 1                                'take amp off line, open relay    
    OUTA[T24voff] := 0                                  '24v off

    InitDisplay
     
'    '============================ Initialize stepper1 to step 0  ====================================

     OUTA[C2stpPin] := 1                                'Set C2stpPin high so motor times out after last pulse
     OUTA[CwCcwPin] := 1                                'Set CwCcwPin for output and CW
     DIRA[LimitDetect] := 0                             'set (limit detect) to input

     repeat while INA[LimitDetect] := 1                 'Repeat while limiter not detected
       PULSOUT (C1stpPin,PulDur)                        'pulse stepper 
      
     OUTA[CwCcwPin] := 1                                'set stepper direction to CW
     PULSOUT (C1stpPin,PulDur)                                              
     stepcnt[1] := 100                                  'set stpcnt1 to origin
     OUTA[CwCcwPin] := 0                                'set stepper direction to CCW

  '    '============================ Initialize stepper2 to step 0  ====================================


     OUTA[L1stpPin] := 1                                'Set L1stpPin high so motor times out after last pulse
     OUTA[CwCcwPin] := 0                                'Set P20 for output and CCW

     DIRA[LimitDetect]:=0                               'set P21 (limit detect) to input 
     repeat while INA[LimitDetect] := 1                 'Repeat while limiter not detected
       PULSOUT (L1stpPin,PulDur)                        'pulse stepper2  

     OUTA[CwCcwPin] := 1                                'set stepper direction to CW
     PULSOUT (L1stpPin,PulDur)                                             
                                         
     stepcnt[2] := 0                                    'set stpcnt2 to origin
     OUTA[CwCcwPin] := 0                                'set stepper direction to CCW

 
  '    '============================ Initialize stepper3 to step 0  ====================================

   
     OUTA[C2stpPin] := 1                                'Set C2stpPin high so motor times out after last pulse
     OUTA[CwCcwPin] := 1                                'Set P20 for output and CW
    
     DIRA[LimitDetect]:=0                               'set P21 (limit detect) to input 
     repeat while INA[LimitDetect] := 1                 'Repeat while limiter not detected
       PULSOUT (C2stpPin,PulDur)                        'pulse stepper3 ~100u 

     OUTA[CwCcwPin] := 0                                'set stepper direction to CCW
     PULSOUT (C2stpPin,PulDur)
     stepcnt[3] := 100                                  'set stpcnt3 to origin
     OUTA[CwCcwPin] := 1                                'set stepper direction to CW

     Tune := 0                                          'Set tune to auto
     WriteObjValue($0F,$04,stepcnt[1])
     WriteObjValue($0F,$05,stepcnt[2])
     WriteObjValue($0F,$06,stepcnt[3])
  

PUB Off
   WriteObjValue($21,$03,$00)
   PST.Str(String(pst#NL," OFF "))
' store stepcnts and freq in eprom
    'countdown
   'fire 5v off
PUB Tstart
  Pst.Str(string(11, 13, "Tstart"))
  start := cnt
   
PUB Tstop
  stop := cnt
  total := stop - start
   Pst.Str(string(pst#NL,"Total =  "))
        Pst.Dec(total)  
PUB ReadObjValue(ObjectId,ObjectIndex) 'Reads the value of a displayed GUI object ...
  transfer := 0

  SendByte(CmdReadValue)                                'Byte 1 is command byte 'CmdReadValue'
  SendByte(ObjectID)                                    'Byte 2 is ObjectID
  SendByte(ObjectIndex)                                 'Byte 3 is Object Index  
  SendChksum                                            'Byte 4 is calculated checksum, of previous bytes

  'Wait for valid report object packet replt from LCD
  result := PollReportObj(true)
  transfer := result
     

  'Return value truncated to the control value (0000-FFFF) only
  result &= $FFFF      
PUB WriteObjValue(ObjectId,ObjectIndex,Value)           'Sets the value of a displayed GUI object

  SendByte(CmdWriteValue)                               'Byte 1 is command byte 'CmdReadValue'  
  SendByte(ObjectID)                                    'Byte 2 is ObjectID
  SendByte(ObjectIndex)                                 'Byte 3 is Object Index
  Sendbyte(Value>>8)                                    'Byte 4 is value upper byte
  SendByte(Value & $FF)                                 'Byte 5 is value lower byte  
  SendChksum                                            'Byte 6 is calculated checksum, of previous bytes

  waitcnt(50000 + cnt)
  
  return RtnBlnAck                                      'Look for ACK NAK response, and return as boolean.. 
                                                        'False=NAK, True = ACK
                                                                                
PRI SendByte(DataByte) 'Local send byte routine, updates checksum, with each byte sent

  LcdSerial.Tx(DataByte)                                'Transmit the byte
  Chksum ^= DataByte                                    'XOR with checksum value to update it

PRI SendChkSum 'Local send checksum routine, sends checksum, then resets it for next packet

  LcdSerial.Tx(ChkSum)                                  'Transmit the checksum value
  Chksum := 0                                           'Reset it, for next transmitted packet

PRI RtnBlnAck  'Look for ACK NAK response, and return as boolean.. False=NAK, True = ACK       
        
  return  LcdSerial.Rx <> NakResp
PUB PollReportObj(Wait)  'Looks for event generated messages in Rx queue

  ''Wait parameter = false, is used for polling async (event raised generated) codes..
  ''Doesnt wait, because an event may not have happen generating a comm event
  ''
  ''Wait parameter = true, is used for polling replies when requested.. needs to wait for LCD to reply

  'Get packet event header byte, with optional wait
  if Wait
    LcdSerial.Rx
  else
    if LcdSerial.RxCheck <0                             'Recieve without wait .. If NOT Object raised event   
      return -1                                         'Return a default error code

  'Read in 4 bytes, and pack into long, in following format...
  'Byte 3 .. Object ID
  'Byte 2 .. Object Index
  'Byte 1 .. Object value MSB
  'Byte 0 .. Object value LSB
  repeat 4
    result <<= 8
    result |= LcdSerial.Rx

  'Read and discard checksum
  LcdSerial.Rx
DAT

pinA                    byte 22, 20, 18
pinB                    byte 23, 21, 19
upperlimit              word 100, 1300, 100
stppin                  byte 17, 0, 1         
DAT Mydata
Byte 100,Word 2600,byte 100  '1.850                                            '1.8-1.9 Mhz         0-3
Byte 100,Word 2600,byte 100  '1.950                                            '1.9-2.0 Mhz         4-7
Byte 61,Word 697,byte 64     '3.612   +                                        '3.5-3.75 Mhz        8-11
Byte 24,Word 754,byte 31     '3.875   ~                                        '3.75-4.0 Mhz       12-15
Byte 22,Word 444,byte 13     '7.075   +                                        '7.0-7.15 Mhz       16-C1stpPin
Byte 39,Word 373,byte 39     '7.225   ~                                        '7.15-7.3 Mhz       20-23
Byte 73,Word 314,byte 97     '10.125  +                                        '10.100-10.150 Mhz  24-27
Byte 52,Word 154,byte 59     '14.075  +                                        '14.0-14.15 Mhz     28-31
Byte 94,Word 219,byte 92     '14.250  +                                        '14.15-14.35 Mhz    32-35
Byte 16,Word 279,byte 14     '18.110  +                                        '18.068-18.168 Mhz  36-39
Byte 27,Word 166,byte 92     '21.100  +                                        '21-21.2 Mhz        40-43
Byte 26,Word 91,byte 94      '21.325  +                                        '21.2-21.45 Mhz     44-47
Byte 18,Word 60,byte 100     '24.95                                            '24.89-24.99 Mhz    48-51
Byte 90,Word 7,byte 31       '28.100                                           '28.0-28.3 Mhz      52-55
Byte 85,Word 1,byte 20       '28.450                                           '28.3-28.6 Mhz      56-59
Byte 100,Word 5,byte 100     '28.750                                           '28.6-29  Mhz       60-63